
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Troubleshooting and Common Pitfalls &#8212; huey 2.0.0 documentation</title>
    <link rel="stylesheet" href="_static/classic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Changes in 2.0" href="changes.html" />
    <link rel="prev" title="Huey Extensions" href="contrib.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="changes.html" title="Changes in 2.0"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="contrib.html" title="Huey Extensions"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">huey 2.0.0 documentation</a> &#187;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="troubleshooting-and-common-pitfalls">
<span id="troubleshooting"></span><h1>Troubleshooting and Common Pitfalls<a class="headerlink" href="#troubleshooting-and-common-pitfalls" title="Permalink to this headline">¶</a></h1>
<p>This document outlines some of the common pitfalls you may encounter when
getting set up with huey.  It is arranged in a problem/solution format.</p>
<dl class="docutils">
<dt>Tasks not running</dt>
<dd><p class="first">First step is to increase logging verbosity by running the consumer with
<code class="docutils literal notranslate"><span class="pre">--verbose</span></code>.  You can also specify a logfile using the <code class="docutils literal notranslate"><span class="pre">--logfile</span></code>
option.</p>
<p class="last">Check for any exceptions.  The most common cause of tasks not running is
that they are not being loaded, in which case you will
see <a class="reference internal" href="api.html#HueyException" title="HueyException"><code class="xref py py-class docutils literal notranslate"><span class="pre">HueyException</span></code></a> “XXX not found in TaskRegistry” errors.</p>
</dd>
<dt>“HueyException: XXX not found in TaskRegistry” in log file</dt>
<dd><p class="first">Exception occurs when a task is called by a task producer, but is not
imported by the consumer.  To fix this, ensure that by loading the
<a class="reference internal" href="api.html#Huey" title="Huey"><code class="xref py py-class docutils literal notranslate"><span class="pre">Huey</span></code></a> object, you also import any decorated functions as well.</p>
<p class="last">For more information on how tasks are imported, see the <a class="reference internal" href="imports.html#imports"><span class="std std-ref">import documentation</span></a>.</p>
</dd>
<dt>“Error importing XXX” when starting consumer</dt>
<dd><p class="first">This error message occurs when the module containing the configuration
specified cannot be loaded (not on the pythonpath, mistyped, etc).  One
quick way to check is to open up a python shell and try to import the
configuration.</p>
<p class="last">Example syntax: <code class="docutils literal notranslate"><span class="pre">huey_consumer.py</span> <span class="pre">main_module.huey</span></code></p>
</dd>
<dt>Tasks not returning results</dt>
<dd>Ensure that you have not accidentally specified <code class="docutils literal notranslate"><span class="pre">results=False</span></code> when
instantiating your <a class="reference internal" href="api.html#Huey" title="Huey"><code class="xref py py-class docutils literal notranslate"><span class="pre">Huey</span></code></a> object.</dd>
<dt>Scheduled tasks are not being run at the correct time</dt>
<dd>Check the time on the server the consumer is running on - if different from
the producer this may cause problems. Huey uses UTC internally by default,
and naive datetimes will be converted from local time to UTC (if local time
happens to not be UTC).</dd>
<dt>Cronjobs are not being run</dt>
<dd>The consumer and scheduler run in UTC by default.</dd>
<dt>Greenlet workers seem stuck</dt>
<dd>If you wish to use the Greenlet worker type, you need to be sure to
monkeypatch in your application’s entrypoint. At the top of your <code class="docutils literal notranslate"><span class="pre">main</span></code>
module, you can add the following code: <code class="docutils literal notranslate"><span class="pre">from</span> <span class="pre">gevent</span> <span class="pre">import</span> <span class="pre">monkey;</span> <span class="pre">monkey.patch_all()</span></code>.
Furthermore, if your tasks are CPU-bound, <code class="docutils literal notranslate"><span class="pre">gevent</span></code> can appear to lock up
because it only supports cooperative multi-tasking (as opposed to
pre-emptive multi-tasking when using threads). For Django, it is necessary
to apply the patch inside the <code class="docutils literal notranslate"><span class="pre">manage.py</span></code> script. See the Django docs
section for the code.</dd>
<dt>Testing projects using Huey</dt>
<dd><p class="first">Use <code class="docutils literal notranslate"><span class="pre">immediate=True</span></code>:</p>
<div class="last highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">test_mode</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;TEST_MODE&#39;</span><span class="p">)</span>

<span class="c1"># When immediate=True, Huey will default to using an in-memory</span>
<span class="c1"># storage layer.</span>
<span class="n">huey</span> <span class="o">=</span> <span class="n">RedisHuey</span><span class="p">(</span><span class="n">immediate</span><span class="o">=</span><span class="n">test_mode</span><span class="p">)</span>

<span class="c1"># Alternatively, you can set the `immediate` attribute:</span>
<span class="n">huey</span><span class="o">.</span><span class="n">immediate</span> <span class="o">=</span> <span class="bp">True</span> <span class="k">if</span> <span class="n">test_model</span> <span class="k">else</span> <span class="bp">False</span>
</pre></div>
</div>
</dd>
</dl>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="contrib.html"
                        title="previous chapter">Huey Extensions</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="changes.html"
                        title="next chapter">Changes in 2.0</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/troubleshooting.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="changes.html" title="Changes in 2.0"
             >next</a> |</li>
        <li class="right" >
          <a href="contrib.html" title="Huey Extensions"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">huey 2.0.0 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2013, charles leifer.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.1.
    </div>
  </body>
</html>